<?php
/***************************************************************************\
 * 				SpipCatChat Salon de Chat autonome pour Spip               *
 *                                                                         *
 *  Copyright (c) 2014                                                     *
 *  Auteur original: Codden Claude			                               *
 *  Traduction anglais: Codden Emmanuel									   *
 *  Chat autonome sur la base de fichier TXT, utilisant les membres 	   *
 *  de la table spip_auteurs.                                              *
 *  Pour plus de details voir le fichier COPYING.txt. 					   *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

header('Content-Type: text/html; charset=UTF-8');
session_start();
//---------Les includes-------//
include('fonction/fonction.php');
include_once('config/constante.php');
require('obj/salon.class.php');
include('fonction/sha256.inc.php');
	if(!$_COOKIE['CATCHAT_LANG'])
	 {
	  setcookie('CATCHAT_LANG',CATCHAT_LANG,time()+3600*24*360); 
	  include('lang/'.CATCHAT_LANG.'.php');
	}
	else
	 {
	 if(!lang())
		{
		setcookie('CATCHAT_LANG',CATCHAT_LANG,time()+3600*24*360); 
		}
	 @include('lang/'.$_COOKIE['CATCHAT_LANG'].'.php'); 
	 }
include('inc/head.php');
//--> Si le fichier SQL.PHP n'éxiste pas, alors nous sommes au niveau de l'installation du systeme 
if(!file_exists('config/sql.php'))
	{	if(lang()){echo lang();}
		$ou_est_spip=mais_ou_est_spip(); //fonction ScanDir pour l'installation en mode automatique, recherche d'un ou voir plusieurs repértoire ECRIRE de SPIP 
		include('inc/install.php');
		echo "<div align='right' style='color:#999999;margin-right:30%'>".$_GLOBALS['lang']['copy']."</div>"; // label copyright 
	}
	else //--> Le fichier SQL existe alors on continue 
	{ 
	if(isset($_POST['login']) AND $_POST['login'])// Permettra de créer l'utilisateur lors de la validation du formulaire
	{
		$db = db_connect();
		/* On crée la variable login qui prend la valeur POST envoyée car on va l'utiliser plusieurs fois */
		$login = $_POST['login'];
		$pass = $_POST['pass'];		
		// On crée une requête pour rechercher un compte ayant pour nom, email, login la variable POST[login]
		$query = $db->prepare("SELECT * FROM spip_auteurs WHERE login = :login OR nom = :login OR email = :login");
		$query->execute(array(
			'login' => $login,
			'nom' => $login,
			'email' => $login
		));
		// On compte le nombre d'entrées
		$count=$query->rowCount();
		$i=0;
		//On recherche l'utilisateur dans une boucle
			while($count>=$i)
			{			
			$data = $query->fetch();	
			//--> hachage en SHA avec le systeme d'alea de SPIP  	
			$shapass = _nano_sha256($data['alea_actuel'] . $pass);
			//--> hachage en MD5 avec le systeme d'alea de SPIP  	
			$md5pass = md5($data['alea_actuel'] . $pass);	
				//--> Test comparatif dans les deux mode du mot de passe pour les différantes verions de SPIP  
				if($data['pass'] == $md5pass || $data['pass'] == $shapass)
				{	//--Ok l'utilisateur existe !!			
					 $_SESSION['catchatid'] = $data['id_auteur'];
					 $_SESSION['catchatlogin'] = $data['login'];
				}
				$i++;
			}	
		// On termine la requête
		$query->closeCursor();
	}
if(!$_SESSION['catchatid']) //--> Si l'utilisateur n'est pas connecté
{	 if(lang()){echo lang();}
	include('inc/formulaire.php');
	echo "<div align='right' style='color:#999999;margin-right:30%'>".$_GLOBALS['lang']['copy']."</div>";
} 
else //--> Si l'utilisateur est connecté
{ 
	if($_POST['SelectMonSalon'] && isset($_GET['start']) )
	{  
		$id_salon=$_POST['SelectMonSalon'];
		//-> On crée l'object salon
		$connect = new salon(CATCHAT_DB);
		$nom_salon=$connect->execut('texte',$id_salon,'');
				$l=$connect->execut('texte',$id_salon+1,'');
			//-> Ici "Anti-Refresh" 
		 if(!$_SESSION['start'])
		 {	// On crée une session time qui prend la valeur de la date et de l'heure d'entrée dans le salon
		 	$_SESSION['catchattime'] = time();
		 	// On passe la variable de SESSION START à vrai pour ne pas effacer 
		 	// le contenu du chat lors du rafraîchissement éventuel de la page.
		 	$_SESSION['start']=true;
		 	}
		if($connect->execut('texte',$id_salon+2,'')=="true" && SALON_PUBLIC)
		{	//True -> nous avons affaire à un salon PUBLIC 
			$_SESSION['catchatSelectMonSalon']=$_POST['SelectMonSalon'];
            $_SESSION['catchatSelectNomSalon']=$nom_salon;
            $_SESSION['catchatSelectCodeSalon']=$l;
            $_SESSION['catchatPublic']=true;
		}
		else
		{ 	//False -> nous avons affaire à un salon PRIVE
					 $data_user=json_decode(file_get_contents(constant('CATCHAT_DB').$l.'/'.$l.'.js'));
				if(is_array($data_user))
				{ //On verifie que la liste des users est bien un tableau pour ne pas planté la procédure suivante.
					$log_user=in_array($_SESSION['catchatid'], $data_user);
					//On confirmer que l'utilisateur a bien l'accès au salon par une recherche de son identifiant dans l'ARRAY   
				}
					//True --> L'utilisateur a autorité, on le "SESSIONNE" pour le salon.
			if($log_user)
				{
				 $_SESSION['catchatPublic']=false;	
				 $_SESSION['catchatSelectCodeSalon']=$l;
                 $_SESSION['catchatSelectMonSalon']=$_POST['SelectMonSalon'];
                 $_SESSION['catchatSelectNomSalon']=$nom_salon;
				 }
				 else
				 { //False --> L'utilisateur reçoit un message d'information 
				 	echo '<script>	alert(\''.addslashes($_GLOBALS['lang']['no_welcom']).'\');	</script>';	
				 }
		}
		//Ici, nous identifions administrateur du salon 
		$_SESSION['catchatAdmin']=$connect->execut('texte',$id_salon+3,'');
	}
	if($_SESSION['catchatSelectMonSalon'] && !isset($_GET['quit']))
		{ //--> Si le salon à été choisi et que nous ne quittons pas le chat, alors on démarre le salon   
			
			if($_SESSION['catchatid']==$_SESSION['catchatAdmin'] && $_SESSION['catchatPublic']==false)
			{//-- Si l'on est administrateur et dans un salon privé, alors : affichage du logo et de la fonction de l'ajout des USERS
				$imgAdmin="<input type='image' title='";
				$imgAdmin.=$_GLOBALS['lang']['title_add_pepole']."' class='pepole' src='images/pepole-26.png' onclick='addpepole();'/>";	
			}
			if($_SESSION['catchatid']==$_SESSION['catchatAdmin'])
			{//-- Si l'on est l'administrateur, on affiche la fonction TRASH du salon que l'on soit en privé ou public
			$confirm='"trash(confirm(\''.addslashes($_GLOBALS['lang']['trash_confirm']).'\'));return false;"';
			$imgAdmin.="<input type='image' title='";
			$imgAdmin.=$_GLOBALS['lang']['title_trash_salon']."' class='pepole' src='images/trash-26.png' onclick=$confirm; />";
			}
					//-- Si l'URL contient ADDUSER en étant l'administrateur du salon "PRIVE",  
					if(isset($_GET['adduser']) && $_SESSION['catchatid']==$_SESSION['catchatAdmin'] && $_SESSION['catchatPublic']==false)
					{ 
						//-->alors on démarre le formulaire d'ajout des membres d'un salon PRIVE 
					include('inc/addusers.php');
					}
					else
					{ 	//-->Si non, on démarre le formulaire CHAT du salon choisi
					include('inc/catchat.php');
					}
		}
	else
		{ 
			if(isset($_GET['end'])) //--> "END" On se déconnect 
			{
				unset(//--> destruction des variables de session "SALON" et des variable d'identification
				$_SESSION['catchatcache'.$_SESSION['catchatSelectCodeSalon']],
				$_SESSION['catchatSelectMonSalon'],
				$_SESSION['catchatPublic'],
				$_SESSION['catchatSelectNomSalon'],
				$_SESSION['catchatSelectCodeSalon'],
				$_SESSION['catchatAdmin'],
				$_SESSION['catchattime'],
				$_SESSION['catchatid'],
				$_SESSION['catchatlogin'] ,
				$connect);
				echo '<script type="text/JavaScript">$(location).attr("href","index.php");</script>';
				}
			else
			{
			unset(//--> destruction des variables de session "SALON"
				$_SESSION['catchatcache'.$_SESSION['catchatSelectCodeSalon']],
				$_SESSION['catchatSelectMonSalon'],
				$_SESSION['catchatPublic'],
				$_SESSION['catchatSelectNomSalon'],
				$_SESSION['catchatSelectCodeSalon'],
				$_SESSION['catchatAdmin'],
				$_SESSION['catchattime'],
				$connect);
			//--Si l'on a quitté le salon --> URL QUIT
			//--> nous incluons alors le formulaire des choix des salons 
			 if(lang()){echo lang();}
			include('inc/select_salon.php');
			echo "<div align='right' style='color:#999999;margin-right:30%'>".$_GLOBALS['lang']['copy']."</div>";
				// On passe la variable de "SESSION START" à faux pour activer la variable de "SESSION catchattime" 
				// et ainsi on n'affiche pas les messages antérieur. 
				$_SESSION['start']=false;
			}
		}
	}
}
?>